Package com.io7m.cedarbridge.version

# Record Class CBVersion

java.lang.Object
java.lang.Record
com.io7m.cedarbridge.version.CBVersion

Record Components:
  `major` - The major version
  `minor` - The minor version
  `patch` - The patch version
  `qualifier` - The qualifier

All Implemented Interfaces:
  `Comparable<CBVersion>`, `Formattable`

public record CBVersion(int major, int minor, int patch, String qualifier) extends Record implements Comparable<CBVersion>, Formattable
A semantic version number.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBVersion(int major, int minor, int patch, String qualifier)`
  A semantic version number.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CBVersion other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `void`
  `formatTo(Formatter formatter, int flags, int width, int precision)`
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `int`
  `major()`
  Returns the value of the `major` record component.
  `int`
  `minor()`
  Returns the value of the `minor` record component.
  `int`
  `patch()`
  Returns the value of the `patch` record component.
  `String`
  `qualifier()`
  Returns the value of the `qualifier` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CBVersion

    public CBVersion(int major, int minor, int patch, String qualifier)
    A semantic version number.
    Parameters:
      `major` - The major version
      `minor` - The minor version
      `patch` - The patch version
      `qualifier` - The qualifier

- ## Method Details

  - ### compareTo

    public int compareTo(CBVersion other)
    Specified by:
      `compareTo` in interface `Comparable<CBVersion>`

  - ### formatTo

    public void formatTo(Formatter formatter, int flags, int width, int precision)
    Specified by:
      `formatTo` in interface `Formattable`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### major

    public int major()
    Returns the value of the `major` record component.
    Returns:
      the value of the `major` record component

  - ### minor

    public int minor()
    Returns the value of the `minor` record component.
    Returns:
      the value of the `minor` record component

  - ### patch

    public int patch()
    Returns the value of the `patch` record component.
    Returns:
      the value of the `patch` record component

  - ### qualifier

    public String qualifier()
    Returns the value of the `qualifier` record component.
    Returns:
      the value of the `qualifier` record component